#ifndef __WPS_PAGE_H__
#define __WPS_PAGE_H__

#include <glib-object.h>
#include <goocanvas.h>

#include "widget.h"
#include "xml.h"
#include "group.h"

#define WPS_TYPE_PAGE			(wps_page_get_type())
#define WPS_PAGE(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), WPS_TYPE_PAGE, WPSPage))
#define WPS_PAGE_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), WPS_TYPE_PAGE, WPSPageClass))
#define WPS_IS_PAGE(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), WPS_TYPE_PAGE))
#define WPS_IS_PAGE_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), WPS_TYPE_PAGE))
#define WPS_PAGE_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), WPS_TYPE_PAGE, WPSPageClass))


typedef struct _WPSPagePrivate WPSPagePrivate;

struct _WPSPage
{
	GObject parent_instance;
	GObject *container;
	GList *widget_list;
	GList *group_list;
	PageInfo *page_info;
	WPSPagePrivate *priv;
};

typedef struct _WPSPage        WPSPage;

struct _WPSPageClass
{
	GObjectClass parent_class;
	void	(*set_page_name)(WPSPage*, gchar*);
	void	(*add_widget)(WPSPage*, GObject *);
	void	(*open_page)(GObject *container, WPSPage *page);
	void	(*close_page)(WPSPage*);
};


typedef struct _WPSPageClass   WPSPageClass;

GType	wps_page_get_type();
//GList	*wps_create_pages_from_info(GList *page_info_list);
GList *wps_create_pages_from_info(GList *page_info_list, GList *template_list);
void	wps_add_widget(WPSPage *page, WPSWidget *widget);
GList	*wps_page_get_widget_list(WPSPage *page);
WPSWidget *wps_page_find_widget_by_name(WPSPage *page, gchar *name);
GList *wps_page_get_group_list(WPSPage *page);
//WPSGroup *wps_page_find_group_by_name(WPSPage *page, gchar *name);

#endif /* __WPS_PAGE_H__ */

